
###

test_all_BM_models <- function(simmap_input,tip_values,model_tests_table) {

####################

tip_values=tip_values[,-1]
tip_values=tip_values[,-1]

###########################################

tree=simmap_input[[1]]
anth_tips=simmap_input[[2]]
strep_tips=simmap_input[[3]]
hystric_tips=simmap_input[[4]]
anom_tips=simmap_input[[5]]
exceptions=simmap_input[[6]]

###########################################

n_tips=length(tree$tip.label)

anth_node=getMRCA(tree,anth_tips)
anth_tips_all=getDescendants(tree,anth_node)
remove_these=which(anth_tips_all>n_tips)
anth_tips_all=anth_tips_all[-remove_these]

strep_node=getMRCA(tree,strep_tips)
strep_tips_all=getDescendants(tree,strep_node)
remove_these=which(strep_tips_all>n_tips)
strep_tips_all=strep_tips_all[-remove_these]

hystric_node=getMRCA(tree,hystric_tips)
hystric_tips_all=getDescendants(tree,hystric_node)
remove_these=which(hystric_tips_all>n_tips)
hystric_tips_all=hystric_tips_all[-remove_these]

anom_node=getMRCA(tree,anom_tips)
anom_tips_all=getDescendants(tree,anom_node)
remove_these=which(anom_tips_all>n_tips)
anom_tips_all=anom_tips_all[-remove_these]

###

clade_assignments=as.vector(rep("",n_tips))
names(clade_assignments)<-tree$tip.label
clade_assignments[anth_tips_all]="anth"
clade_assignments[strep_tips_all]="strep"
clade_assignments[hystric_tips_all]="hystric"
clade_assignments[anom_tips_all]="anom"

###

test=length(exceptions)
if(test>1) { #from here
n_exceptions=dim(exceptions)[1]
count=1
repeat {
tip_name=exceptions[count,1]
tip_clade=exceptions[count,2]
tip_number=which(names(clade_assignments)==tip_name)
clade_assignments[tip_number]=tip_clade
count=count+1
if(count==n_exceptions+1) break }
} #to here

##################################################

simmap_tree=make.simmap(tree,clade_assignments,model="ER",nsim=1,message=FALSE)

##################################################

param_indy=list(constraint="diagonal",smean=T,trend=F)
param_joint=list(constraint="equal",smean=T,trend=F)
param_covary=list(constraint=F,smean=T,trend=F)

#####

#run the first batch of tests (n=6)
count=1

model_ID=1
model=mvBM(simmap_tree,tip_values,model="BM1",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=2
model=mvBM(simmap_tree,tip_values,model="BM1",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=3
model=mvBM(simmap_tree,tip_values,model="BM1",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

###

model_ID=43
model=mvBM(simmap_tree,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=44
model=mvBM(simmap_tree,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=45
model=mvBM(simmap_tree,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

############################################################

#start combination clade assignments

anth_tips=which(clade_assignments=="anth")
strep_tips=which(clade_assignments=="strep")
hystric_tips=which(clade_assignments=="hystric")
anom_tips=which(clade_assignments=="anom")

###

clade_assignments_456=clade_assignments
clade_assignments_456[anth_tips]="anth_strep"
clade_assignments_456[strep_tips]="anth_strep"
clade_assignments_456[hystric_tips]="hystric_anom"
clade_assignments_456[anom_tips]="hystric_anom"

clade_assignments_789=clade_assignments
clade_assignments_789[anth_tips]="anth_hystric"
clade_assignments_789[hystric_tips]="anth_hystric"
clade_assignments_789[strep_tips]="strep_anom"
clade_assignments_789[anom_tips]="strep_anom"

clade_assignments_101112=clade_assignments
clade_assignments_101112[anth_tips]="anth_anom"
clade_assignments_101112[anom_tips]="anth_anom"
clade_assignments_101112[strep_tips]="strep_hystric"
clade_assignments_101112[hystric_tips]="strep_hystric"

clade_assignments_131415=clade_assignments
clade_assignments_131415[anth_tips]="anth"
clade_assignments_131415[strep_tips]="strep_hystric_anom"
clade_assignments_131415[hystric_tips]="strep_hystric_anom"
clade_assignments_131415[anom_tips]="strep_hystric_anom"

clade_assignments_161718=clade_assignments
clade_assignments_161718[strep_tips]="strep"
clade_assignments_161718[anth_tips]="anth_hystric_anom"
clade_assignments_161718[hystric_tips]="anth_hystric_anom"
clade_assignments_161718[anom_tips]="anth_hystric_anom"

clade_assignments_192021=clade_assignments
clade_assignments_192021[hystric_tips]="hystric"
clade_assignments_192021[anth_tips]="anth_strep_anom"
clade_assignments_192021[strep_tips]="anth_strep_anom"
clade_assignments_192021[anom_tips]="anth_strep_anom"

clade_assignments_222324=clade_assignments
clade_assignments_222324[anom_tips]="anom"
clade_assignments_222324[anth_tips]="anth_strep_hystric"
clade_assignments_222324[strep_tips]="anth_strep_hystric"
clade_assignments_222324[hystric_tips]="anth_strep_hystric"

clade_assignments_252627=clade_assignments
clade_assignments_252627[anth_tips]="anth"
clade_assignments_252627[strep_tips]="strep"
clade_assignments_252627[hystric_tips]="hystric_anom"
clade_assignments_252627[anom_tips]="hystric_anom"

clade_assignments_282930=clade_assignments
clade_assignments_282930[anth_tips]="anth"
clade_assignments_282930[hystric_tips]="hystric"
clade_assignments_282930[strep_tips]="strep_anom"
clade_assignments_282930[anom_tips]="strep_anom"

clade_assignments_313233=clade_assignments
clade_assignments_313233[anth_tips]="anth"
clade_assignments_313233[anom_tips]="anom"
clade_assignments_313233[strep_tips]="strep_hystric"
clade_assignments_313233[hystric_tips]="strep_hystric"

clade_assignments_343536=clade_assignments
clade_assignments_343536[strep_tips]="strep"
clade_assignments_343536[hystric_tips]="hystric"
clade_assignments_343536[anth_tips]="anth_anom"
clade_assignments_343536[anom_tips]="anth_anom"

clade_assignments_373839=clade_assignments
clade_assignments_373839[strep_tips]="strep"
clade_assignments_373839[anom_tips]="anom"
clade_assignments_373839[anth_tips]="anth_hystric"
clade_assignments_373839[hystric_tips]="anth_hystric"

clade_assignments_404142=clade_assignments
clade_assignments_404142[hystric_tips]="hystric"
clade_assignments_404142[anom_tips]="anom"
clade_assignments_404142[anth_tips]="anth_strep"
clade_assignments_404142[strep_tips]="anth_strep"

###

simmap_tree_456=make.simmap(tree,clade_assignments_456,model="ER",nsim=1,message=FALSE)
simmap_tree_789=make.simmap(tree,clade_assignments_789,model="ER",nsim=1,message=FALSE)
simmap_tree_101112=make.simmap(tree,clade_assignments_101112,model="ER",nsim=1,message=FALSE)
simmap_tree_131415=make.simmap(tree,clade_assignments_131415,model="ER",nsim=1,message=FALSE)
simmap_tree_161718=make.simmap(tree,clade_assignments_161718,model="ER",nsim=1,message=FALSE)
simmap_tree_192021=make.simmap(tree,clade_assignments_192021,model="ER",nsim=1,message=FALSE)
simmap_tree_222324=make.simmap(tree,clade_assignments_222324,model="ER",nsim=1,message=FALSE)
simmap_tree_252627=make.simmap(tree,clade_assignments_252627,model="ER",nsim=1,message=FALSE)
simmap_tree_282930=make.simmap(tree,clade_assignments_282930,model="ER",nsim=1,message=FALSE)
simmap_tree_313233=make.simmap(tree,clade_assignments_313233,model="ER",nsim=1,message=FALSE)
simmap_tree_343536=make.simmap(tree,clade_assignments_343536,model="ER",nsim=1,message=FALSE)
simmap_tree_373839=make.simmap(tree,clade_assignments_373839,model="ER",nsim=1,message=FALSE)
simmap_tree_404142=make.simmap(tree,clade_assignments_404142,model="ER",nsim=1,message=FALSE)

##################################################

#test more models

model_ID=4
model=mvBM(simmap_tree_456,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=5
model=mvBM(simmap_tree_456,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=6
model=mvBM(simmap_tree_456,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=7
model=mvBM(simmap_tree_789,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=8
model=mvBM(simmap_tree_789,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=9
model=mvBM(simmap_tree_789,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=10
model=mvBM(simmap_tree_101112,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=11
model=mvBM(simmap_tree_101112,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=12
model=mvBM(simmap_tree_101112,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=13
model=mvBM(simmap_tree_131415,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=14
model=mvBM(simmap_tree_131415,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=15
model=mvBM(simmap_tree_131415,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=16
model=mvBM(simmap_tree_161718,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=17
model=mvBM(simmap_tree_161718,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=18
model=mvBM(simmap_tree_161718,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=19
model=mvBM(simmap_tree_192021,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=20
model=mvBM(simmap_tree_192021,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=21
model=mvBM(simmap_tree_192021,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=22
model=mvBM(simmap_tree_222324,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=23
model=mvBM(simmap_tree_222324,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=24
model=mvBM(simmap_tree_222324,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=25
model=mvBM(simmap_tree_252627,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=26
model=mvBM(simmap_tree_252627,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=27
model=mvBM(simmap_tree_252627,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=28
model=mvBM(simmap_tree_282930,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=29
model=mvBM(simmap_tree_282930,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=30
model=mvBM(simmap_tree_282930,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=31
model=mvBM(simmap_tree_313233,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=32
model=mvBM(simmap_tree_313233,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=33
model=mvBM(simmap_tree_313233,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=34
model=mvBM(simmap_tree_343536,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=35
model=mvBM(simmap_tree_343536,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=36
model=mvBM(simmap_tree_343536,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=37
model=mvBM(simmap_tree_373839,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=38
model=mvBM(simmap_tree_373839,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=39
model=mvBM(simmap_tree_373839,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=40
model=mvBM(simmap_tree_404142,tip_values,model="BMM",param=param_indy,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=41
model=mvBM(simmap_tree_404142,tip_values,model="BMM",param=param_joint,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

model_ID=42
model=mvBM(simmap_tree_404142,tip_values,model="BMM",param=param_covary,method="inverse",diagnostic=FALSE,echo=FALSE)
model_n_parameters=model$param$nparam
model_tests_table[model_ID,5]=model_n_parameters
model_AICc=model$AICc
model_tests_table[model_ID,6]=model_AICc
my_message=paste(count,"of 45 completed")
print(my_message,quote=F)
flush.console()
count=count+1

###

model_tests_table_2=model_tests_table[order(model_tests_table[,6]),]
n_models=length(model_tests_table_2[,1])
my_seq=seq(from=1,to=n_models,by=1)
model_tests_table_2[,7]=my_seq

options(scipen=999)
write.table(model_tests_table_2,"model_tests_results.txt",sep="\t",row.names=F,col.names=T,quote=F)

###

print(model_tests_table_2,justify="left")
flush.console()

#####################

return(model_tests_table_2) }


