
###

make_simmap_tree <- function(simmap_input) {

####################

tree=simmap_input[[1]]
anth_tips=simmap_input[[2]]
strep_tips=simmap_input[[3]]
hystric_tips=simmap_input[[4]]
anom_tips=simmap_input[[5]]
exceptions=simmap_input[[6]]

###

n_tips=length(tree$tip.label)

anth_node=getMRCA(tree,anth_tips)
anth_tips_all=getDescendants(tree,anth_node)
remove_these=which(anth_tips_all>n_tips)
anth_tips_all=anth_tips_all[-remove_these]

strep_node=getMRCA(tree,strep_tips)
strep_tips_all=getDescendants(tree,strep_node)
remove_these=which(strep_tips_all>n_tips)
strep_tips_all=strep_tips_all[-remove_these]

hystric_node=getMRCA(tree,hystric_tips)
hystric_tips_all=getDescendants(tree,hystric_node)
remove_these=which(hystric_tips_all>n_tips)
hystric_tips_all=hystric_tips_all[-remove_these]

anom_node=getMRCA(tree,anom_tips)
anom_tips_all=getDescendants(tree,anom_node)
remove_these=which(anom_tips_all>n_tips)
anom_tips_all=anom_tips_all[-remove_these]

###

clade_assignments=as.vector(rep("",n_tips))
names(clade_assignments)<-tree$tip.label
clade_assignments[anth_tips_all]="anth"
clade_assignments[strep_tips_all]="strep"
clade_assignments[hystric_tips_all]="hystric"
clade_assignments[anom_tips_all]="anom"

###

test=length(exceptions)
if(test>1) { #from here
n_exceptions=dim(exceptions)[1]
count=1
repeat {
tip_name=exceptions[count,1]
tip_clade=exceptions[count,2]
tip_number=which(names(clade_assignments)==tip_name)
clade_assignments[tip_number]=tip_clade
count=count+1
if(count==n_exceptions+1) break }
} #to here

###

simmap_tree=make.simmap(tree,clade_assignments,model="ER",nsim=1,message=FALSE)
colors=c("blue","red","green","orange")
names(colors)=c("anth","strep","hystric","anom")

dev.new(width=15,height=7)
plotSimmap(simmap_tree,colors,fsize=0.7,node.numbers=FALSE,lwd=2,pts=FALSE,direction="upwards")

####################

return(simmap_tree) }

